'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _leaflet = require('leaflet');

var _leaflet2 = _interopRequireDefault(_leaflet);

var _reactLeaflet = require('react-leaflet');

var _reactLeafletDraw = require('react-leaflet-draw');

require('leaflet/dist/leaflet.css');

require('../temp-leaflet-container.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// return a subset of the input props, to the top level Map component


// temp - leaflet CSS - I will only include this in storybook
//    no need to bundle this w/ npm
var pickMapProps = function pickMapProps(mapData) {
  return _lodash2.default.pick(mapData, ['center', 'zoom', 'style']);
};
// and a CSS file for the draw portion
// import './leaflet.draw.css'; <-- loading in .storybook/head.html
// temp - my custom CSS = crappy hacks, I'd like to remove


var ReactLeafletPolytools = function ReactLeafletPolytools(_ref) {
  var style = _ref.style,
      onClick = _ref.onClick,
      defaultMapData = _ref.defaultMapData,
      props = (0, _objectWithoutProperties3.default)(_ref, ['style', 'onClick', 'defaultMapData']);

  var mapData = _lodash2.default.extend(defaultMapData, props);
  return _react2.default.createElement(
    _reactLeaflet.Map,
    pickMapProps(mapData),
    _react2.default.createElement(_reactLeaflet.TileLayer, {
      url: 'http://{s}.tile.osm.org/{z}/{x}/{y}.png',
      attribution: '\xA9 <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
    }),
    _react2.default.createElement(
      _reactLeaflet.FeatureGroup,
      null,
      _react2.default.createElement(_reactLeafletDraw.EditControl, {
        position: 'topright',
        onEdited: props.onChanged,
        onCreated: props.onChanged,
        onDeleted: props.onChanged,
        draw: {
          rectangle: false
        }
      }),
      _react2.default.createElement(_reactLeaflet.Circle, { center: [51.51, -0.06], radius: 200 })
    )
  );
};
ReactLeafletPolytools.propTypes = {
  children: _propTypes2.default.string.isRequired,
  onClick: _propTypes2.default.func,
  style: _propTypes2.default.object,
  defaultMapData: _propTypes2.default.object,
  canAddPolygon: _propTypes2.default.func,
  canEditPolygon: _propTypes2.default.func,
  canDeletePolygon: _propTypes2.default.func,
  onChange: _propTypes2.default.func
};
ReactLeafletPolytools.defaultProps = {
  // here are some defaults you can specify
  // all of these can be passed in directly into the component
  defaultMapData: {
    center: [51.505, -0.09],
    zoom: 13
  },
  style: {
    minHeight: 300
  },
  canAddPolygon: function canAddPolygon(mapData) {
    return true;
  },
  canEditPolygon: function canEditPolygon(mapData) {
    return true;
  },
  canDeletePolygon: function canDeletePolygon(mapData) {
    return true;
  },
  onChange: function onChange(mapData) {
    return console.log('map data changed', mapData);
  }
};

exports.default = ReactLeafletPolytools;